  MEMBER

  include('ConcurrencyClass.inc'),ONCE
  INCLUDE('CWSYNCHM.INC'),ONCE
  INCLUDE('JSONObject.inc'),ONCE

                              MAP
                              end!m

ConcurrencyClass.Construct    PROCEDURE
  CODE
  SELF.SyncRoot &= NewCriticalSection()
  SELF.Q &= NEW ConcurrencyQ
  
ConcurrencyClass.Destruct    PROCEDURE
  CODE
  DISPOSE(SELF.SyncRoot)
  FREE(SELF.Q)
  DISPOSE(SELF.Q)
  
ConcurrencyClass.SetWebSocketServer    PROCEDURE(WebSocketServerClass p_ws)
  CODE
  SELF.WS &= p_ws
  
ConcurrencyClass.HandleOpen   PROCEDURE(LONG p_SockID)
CP                              CriticalProcedure
jMessage                        JSONObject
SendBuffer                      StringTheory
  CODE
  CP.init(SELF.SyncRoot)
  SELF.Q.SockID = p_SockID
  GET(SELF.Q, SELF.Q.SockID)
  if errorcode()
    SELF.Q.SockID = p_SockID
    ADD(SELF.Q,SELF.Q.SockID)
  ELSE
    SELF.Q.FormID =''
    PUT(SELF.Q)
  end!if
  jMessage.Add('MsgType','OPEN')
  jMessage.Add('SockID', p_SockID, json:Numeric)
  jMessage.Stringify(SENDBuffer)
  SELF.WS.SendText(p_SockID,SendBuffer)
    
ConcurrencyClass.HandleClose                     PROCEDURE(LONG p_SockID)
CP                              CriticalProcedure
  CODE
  CP.init(SELF.SyncRoot)
  SELF.Q.SockID = p_SockID
  GET(SELF.Q, SELF.Q.SockID)
  if ~errorcode()
    DELETE(SELF.Q)
  end!if
  
ConcurrencyClass.HandleMailBoxOpen    PROCEDURE(LONG p_SockID, STRING p_userID, STRING p_FormID)
CP                              CriticalProcedure
  CODE
  CP.init(SELF.SyncRoot)
  SELF.Q.SockID = p_SockID
  GET(SELF.Q, SELF.Q.SockID)
  if ~errorcode()
    SELF.Q.UserID = p_userID
    SELF.Q.FormID = p_FormID
    PUT(SELF.Q)
  end!if
  SELF._updateClients(p_FormID)
  
ConcurrencyClass.HandleMailBoxClose   PROCEDURE(LONG p_SockID)
CP                              CriticalProcedure
FormId                                  STRING(100)
  CODE
  CP.init(SELF.SyncRoot)
  SELF.Q.SockID = p_SockID
  GET(SELF.Q, SELF.Q.SockID)
  if ~errorcode()
    FormId = SELF.Q.FormID
    SELF.Q.FormID = ''
    PUT(SELF.Q)
  end!if
  if FormId <> ''
    SELF._updateClients(FormId, p_SockID)
  end!if
  
ConcurrencyClass._updateClients   PROCEDURE(STRING p_formId, LONG p_SockID = 0)
CP                              CriticalProcedure
cc                                  LONG
FormClient                          JSONObject
jUsers                              &JSONObject
o                                   &JSONObject
sendBuffer                          StringTheory
  CODE
  CP.init(SELF.SyncRoot)
  FormClient.Add('MsgType','UPDATE')
  jUsers &= FormClient.Add('Users')  
  LOOP cc = 1 to records(SELF.Q)
    GET(SELF.Q,cc)
    if SELF.Q.FormID = p_formId
      o &= jUsers.AddItem()
      o.Add('UserID',CLIP(SELF.Q.UserID))
      o.Add('SockID',SELF.Q.SockID,json:Numeric)      
    end!if
  end!loop
  FormClient.Stringify(sendBuffer)
  LOOP cc = 1 to records(SELF.Q)
    GET(SELF.Q,cc)
    if SELF.Q.FormID = p_formId OR SELF.Q.SockID = p_SockID
      SELF.WS.SendText(SELF.Q.SockID, sendBuffer)
    end!if
  end!loop

ConcurrencyClass.HandleMessage                   procedure(LONG p_SockID, JSONObject p_o)
ToSockID                                              LONG

jMessage                                               JSONObject
CP                              CriticalProcedure
SendBuffer                      StringTheory
  CODE
  CP.init(SELF.SyncRoot)
  if ~p_o &= NULL
    case p_o.GetPropertyValue('MsgType')
    of 'SEND'
      ToSockID = p_o.GetPropertyValue('ToSocket')      
      SELF.Q.SockID = p_SockID
      GET(SELF.Q, SELF.Q.SockID)
      if ~errorcode()
        jMessage.Add('MsgType','CHAT') 
        jMessage.Add('UserID', CLIP(SELF.Q.UserID))
        jMessage.Add('Message', p_o.GetPropertyValue('Message'))
        jMessage.Add('SockID', p_SockID)
        jMessage.Stringify(SendBuffer)
        
        SELF.WS.SendText(ToSockID, SendBuffer)
      end!if
    end!case
  end!if