

   MEMBER('web1.clw')                                      ! This is a MEMBER module


   INCLUDE('NetWeb.inc'),ONCE

                     MAP
                       INCLUDE('WEB1004.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('WEB1005.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('WEB1009.INC'),ONCE        !Req'd for module callout resolution
                     END


WebHandler           PROCEDURE (String p_ReqString)

loc:file                              &FILE
!Local Data Classes
p_web                CLASS(NetWebServerWorker)             ! Generated by NetTalk Extension (Class Definition)
AddFile                PROCEDURE(FILE p_file),LONG,PROC,DERIVED
CallForm               PROCEDURE(FILE p_file,LONG p_Stage),LONG,PROC,DERIVED
CloseFile              PROCEDURE(FILE p_file),LONG,PROC,DERIVED
DeleteFile             PROCEDURE(FILE p_file),LONG,PROC,DERIVED
GetFile                PROCEDURE(FILE p_file,KEY p_Key),LONG,PROC,DERIVED
OpenFile               PROCEDURE(FILE p_file),LONG,PROC,DERIVED
PrimeFile              PROCEDURE(FILE p_file,Long p_Clear,Long p_forceWrite=False),LONG,PROC,DERIVED
ProcessLink            PROCEDURE(<string p_action>),DERIVED
ProcessTag             PROCEDURE(string p_TagString),DERIVED
SetPics                PROCEDURE(FILE p_file),DERIVED
SetSessionPics         PROCEDURE(FILE p_file),DERIVED
UpdateFile             PROCEDURE(FILE p_file),LONG,PROC,DERIVED
_NetWebFileNamed       PROCEDURE(STRING p_Label),*FILE,DERIVED
_SendFile              PROCEDURE(string p_FileName,Long p_header=NET:SendHeader),DERIVED
_SetMobile             PROCEDURE(),DERIVED

                     END


  CODE
  GlobalErrors.SetProcedureName('WebHandler')
  p_web.ProcessRequest(p_ReqString)
  GlobalErrors.SetProcedureName()

p_web.AddFile PROCEDURE(FILE p_file)

ReturnValue          LONG,AUTO

RM      &RelationManager
Loc:Err Long(-1)

  CODE
    RM &= NetWebRelationManager(p_File)
    If NOT RM &= Null
      self.SetSqlTimeout(p_File,net:On)
      Loc:Err = RM.Me.Insert()
      self.SetSqlTimeout(p_File,net:Off)
      Self.FileToSessionQueue(p_File,Net:AlsoValueQueue)
    End
    Return Loc:Err
  ReturnValue = PARENT.AddFile(p_file)
  RETURN ReturnValue


p_web.CallForm PROCEDURE(FILE p_file,LONG p_Stage)

ReturnValue          LONG,AUTO


  CODE
    If Band(p_Stage, NET:WEB:StagePost + NET:WEB:StageValidate + NET:WEB:Cancel)
      case lower(self.formsettings.proc)
      Of 'wsform'
         ReturnValue = WSForm(Self,p_stage)
         RETURN ReturnValue
      Of 'mailboxesformcontrol'
         ReturnValue = MailboxesFormControl(Self,p_stage)
         RETURN ReturnValue
      End
    Else
      case lower(SELF.PageName)
        Of 'wsform'
             ReturnValue = WSForm(Self,p_stage)
           RETURN ReturnValue
        Of 'mailboxesformcontrol'
             ReturnValue = MailboxesFormControl(Self,p_stage)
           RETURN ReturnValue
        Of 'wspage'
             ReturnValue = WSForm(Self,p_stage)
           RETURN ReturnValue
      End
    End
    If p_File &= mailboxes
       ReturnValue = MailboxesFormControl(Self,p_stage)
       RETURN ReturnValue
    End
    Case Lower(Self.FormSettings.ParentPage)
      Of 'wsform'
        ReturnValue = WSForm(Self,p_Stage)
        Return ReturnValue
    End
  ReturnValue = PARENT.CallForm(p_file,p_Stage)
  RETURN ReturnValue


p_web.CloseFile PROCEDURE(FILE p_file)

ReturnValue          LONG,AUTO

RM      &RelationManager
Loc:Err Long(-1)

  CODE
    RM &= NetWebRelationManager(p_File)
    If NOT RM &= Null
      Loc:Err = RM.Close()  ! doing an rm.close can cause problems.
    end
    Return Loc:Err
  ReturnValue = PARENT.CloseFile(p_file)
  RETURN ReturnValue


p_web.DeleteFile PROCEDURE(FILE p_file)

ReturnValue          LONG,AUTO

RM      &RelationManager
Loc:Err Long(-1)

  CODE
    RM &= NetWebRelationManager(p_File)
    If NOT RM &= Null
      self.SetSqlTimeout(p_File,net:On)
      Loc:Err = RM.Delete(False)
      self.SetSqlTimeout(p_File,net:Off)
    End
    Return Loc:Err
  ReturnValue = PARENT.DeleteFile(p_file)
  RETURN ReturnValue


p_web.GetFile PROCEDURE(FILE p_file,KEY p_Key)

ReturnValue          LONG,AUTO

RM      &RelationManager
Loc:Err Long(-1)

  CODE
    RM &= NetWebRelationManager(p_File)
    If NOT RM &= Null
      self.SetSqlTimeout(p_File,net:On)
      Loc:Err = RM.Me.Fetch(p_Key)
      RM.Save()                    ! saves related file info so relational update will work.
      self.SetSqlTimeout(p_File,net:Off)
    End
    Return Loc:Err
  ReturnValue = PARENT.GetFile(p_file,p_Key)
  RETURN ReturnValue


p_web.OpenFile PROCEDURE(FILE p_file)

ReturnValue          LONG,AUTO

RM      &RelationManager
Loc:Err Long(-1)

  CODE
    RM &= NetWebRelationManager(p_File)
    If NOT RM &= Null
      Loc:Err = RM.Open()
    End
    Return Loc:Err
  ReturnValue = PARENT.OpenFile(p_file)
  RETURN ReturnValue


p_web.PrimeFile PROCEDURE(FILE p_file,Long p_Clear,Long p_forceWrite=False)

ReturnValue          LONG,AUTO

RM      &RelationManager
Loc:Err Long(-1)

  CODE
    RM &= NetWebRelationManager(p_File)
    If NOT RM &= Null
      !If p_forceWrite then RM.Me.HasAutoInc = true. ! this forces an Insert, even if no keys are set as auto-inc, like in the case of a server side Identity field.
      self.SetSqlTimeout(p_File,net:On)
      Loc:Err = RM.Me.PrimeRecord(p_Clear)
      self.SetSqlTimeout(p_File,net:Off)
      Self.FileToSessionQueue(p_File,Net:AlsoValueQueue)
    End
    Return Loc:Err
  ReturnValue = PARENT.PrimeFile(p_file,p_Clear,p_forceWrite)
  RETURN ReturnValue


p_web.ProcessLink PROCEDURE(<string p_action>)


  CODE
  ! C5.5:  file{prop:name} = clip(self.site.appPath) & 'file.tps'
  PARENT.ProcessLink(p_action)


p_web.ProcessTag PROCEDURE(string p_TagString)

loc:tag      String(1024)

  CODE
  PARENT.ProcessTag(p_TagString)
    loc:tag = lower(p_TagString)
  loc:tag = Choose(Instring('?',loc:tag) > 0,sub(loc:tag,1,Instring('?',loc:tag)-1),loc:tag)
  Case loc:tag
    of 'pagefootertag'
      pagefootertag(Self)
    of 'pageheadertag'
      pageheadertag(Self)
    of 'mailboxesbrowsecontrol'
      mailboxesbrowsecontrol(Self)
    of 'wsform'
      wsform(Self)
    of 'mailboxesformcontrol'
      mailboxesformcontrol(Self)
  End


p_web.SetPics PROCEDURE(FILE p_file)


  CODE
  PARENT.SetPics(p_file)
    ! If you're getting an Error here then you probably have forgotten to add the
    ! _2nd_ global extension, the one called "NetWebServerGlobal".
    NetWebSetPics(Self,p_File)


p_web.SetSessionPics PROCEDURE(FILE p_file)


  CODE
  PARENT.SetSessionPics(p_file)
    NetWebSetSessionPics(Self,p_File)


p_web.UpdateFile PROCEDURE(FILE p_file)

ReturnValue          LONG,AUTO

RM      &RelationManager
Loc:Err Long(-1)

  CODE
    RM &= NetWebRelationManager(p_File)
    If NOT RM &= Null
      self.SetSqlTimeout(p_File,net:On)
      Loc:Err = RM.Update()
      self.SetSqlTimeout(p_File,net:Off)
      Self.FileToSessionQueue(p_File,Net:AlsoValueQueue)
    End
    Return Loc:Err
  ReturnValue = PARENT.UpdateFile(p_file)
  RETURN ReturnValue


p_web._NetWebFileNamed PROCEDURE(STRING p_Label)

ReturnValue          &FILE


  CODE
    ReturnValue &= NetWebFileNamed(p_Label)
    Return ReturnValue
  ReturnValue &= PARENT._NetWebFileNamed(p_Label)
  RETURN ReturnValue


p_web._SendFile PROCEDURE(string p_FileName,Long p_header=NET:SendHeader)

loc:parent  string(252)   ! should always be a lower-case string
loc:done        Long
loc:filename    string(252)

  CODE
  
    loc:parent = Lower(self.GetValue('_parentProc_'))
    loc:filename = SELF.GetPageName(Lower(p_FileName))
  
    do CaseStart:web1
    If loc:Done then Return.
  
  PARENT._SendFile(p_FileName,p_header)
CallLoginPage  routine
  If self.site.LoginPageIsControl
    self.MakePage(self.site.LoginPage)
  else
    self._SendFile(self.site.LoginPage)
  End

CaseStart:web1  routine
  do Case:WSPage
  do Case:PageFooterTag
  do Case:PageHeaderTag
  do Case:IndexPage
  do Case:MailboxesBrowseControl
  do Case:WSForm
  do Case:MailboxesFormControl

! - -  - - - - - - - - - - - - - -
Case:WSPage  Routine
  Case loc:filename
  of 'wspage'
  orof 'websockets demo page'
    WSPage(self)
    loc:Done = 1 ; Exit
  End ! Case
! - -  - - - - - - - - - - - - - -
Case:PageFooterTag  Routine
  Case loc:filename
  of 'pagefootertag'
  orof 'pagefootertag' & '_' & loc:parent
      self.Ajax = 1
      PageFooterTag(self)
      self.Sendfooter(12)
      loc:Done = 1
  End ! Case
! - -  - - - - - - - - - - - - - -
Case:PageHeaderTag  Routine
  Case loc:filename
  of 'pageheadertag'
  orof 'pageheadertag' & '_' & loc:parent
      self.Ajax = 1
      PageHeaderTag(self)
      self.Sendfooter(12)
      loc:Done = 1
  End ! Case
! - -  - - - - - - - - - - - - - -
Case:IndexPage  Routine
  Case loc:filename
  of 'indexpage'
  orof 'index.htm'
    IndexPage(self)
    loc:Done = 1 ; Exit
  End ! Case
! - -  - - - - - - - - - - - - - -
Case:MailboxesBrowseControl  Routine
  Case loc:filename
  of 'mailboxesbrowsecontrol'
  orof 'mailboxesbrowsecontrol' & '_' & loc:parent
    Self.MakePage('MailboxesBrowseControl',Net:Web:Browse,0,'Mailboxes',,)
    loc:Done = 1
    loc:Done = 1
  End ! Case
! - -  - - - - - - - - - - - - - -
Case:WSForm  Routine
  Case loc:filename
  of 'wsform'
    Self.MakePage('WSForm',Net:Web:Form,0,'Session vars form',,)
    loc:Done = 1 ; Exit
  of self.nocolon('wsform_tabchanged')
    WSForm(self,Net:Web:Div)
  of self.nocolon('wsform_nexttab_0')
    WSForm(self,Net:Web:NextTab)
    self.Sendfooter(5)
    loc:Done = 1 ; Exit
  of self.nocolon('wsform_tab_0')
  orof self.nocolon('wsform_loc:username_value')
  orof self.nocolon('wsform_loc:username_value')
    WSForm(self,Net:Web:Div)
    self.Sendfooter(11)
    loc:Done = 1
  of self.nocolon('wsform_nexttab_1')
    WSForm(self,Net:Web:NextTab)
    self.Sendfooter(5)
    loc:Done = 1 ; Exit
  of self.nocolon('wsform_tab_1')
  orof self.nocolon('wsform_btnconnect_value')
    WSForm(self,Net:Web:Div)
    self.Sendfooter(11)
    loc:Done = 1
  End ! Case
! - -  - - - - - - - - - - - - - -
Case:MailboxesFormControl  Routine
  Case loc:filename
  of 'mailboxesformcontrol'
    Self.MakePage('MailboxesFormControl',Net:Web:Form,0,'Mailbox Setup',,)
    loc:Done = 1 ; Exit
  of self.nocolon('mailboxesformcontrol_tabchanged')
    MailboxesFormControl(self,Net:Web:Div)
  of self.nocolon('mailboxesformcontrol_nexttab_0')
    MailboxesFormControl(self,Net:Web:NextTab)
    self.Sendfooter(5)
    loc:Done = 1 ; Exit
  of self.nocolon('mailboxesformcontrol_tab_0')
  orof self.nocolon('mailboxesformcontrol_mai:mailboxname_value')
  orof self.nocolon('mailboxesformcontrol_mai:mailboxname_value')
  orof self.nocolon('mailboxesformcontrol_mai:password_value')
  orof self.nocolon('mailboxesformcontrol_mai:password_value')
  orof self.nocolon('mailboxesformcontrol_mai:startdate_value')
  orof self.nocolon('mailboxesformcontrol_mai:startdate_value')
  orof self.nocolon('mailboxesformcontrol_mai:sizelimit_value')
  orof self.nocolon('mailboxesformcontrol_mai:sizelimit_value')
    MailboxesFormControl(self,Net:Web:Div)
    self.Sendfooter(11)
    loc:Done = 1
  of self.nocolon('mailboxesformcontrol_nexttab_1')
    MailboxesFormControl(self,Net:Web:NextTab)
    self.Sendfooter(5)
    loc:Done = 1 ; Exit
  of self.nocolon('mailboxesformcontrol_tab_1')
  orof self.nocolon('mailboxesformcontrol_mai:forwardonly_value')
  orof self.nocolon('mailboxesformcontrol_mai:forwardonly_value')
  orof self.nocolon('mailboxesformcontrol_mai:forwardaddress_value')
  orof self.nocolon('mailboxesformcontrol_mai:forwardaddress_value')
    MailboxesFormControl(self,Net:Web:Div)
    self.Sendfooter(11)
    loc:Done = 1
  of self.nocolon('mailboxesformcontrol_nexttab_2')
    MailboxesFormControl(self,Net:Web:NextTab)
    self.Sendfooter(5)
    loc:Done = 1 ; Exit
  of self.nocolon('mailboxesformcontrol_tab_2')
  orof self.nocolon('mailboxesformcontrol_mai:autoresponse_value')
  orof self.nocolon('mailboxesformcontrol_mai:autoresponse_value')
  orof self.nocolon('mailboxesformcontrol_mai:autoresponsefrom_value')
  orof self.nocolon('mailboxesformcontrol_mai:autoresponsefrom_value')
  orof self.nocolon('mailboxesformcontrol_mai:autoreponsesubject_value')
  orof self.nocolon('mailboxesformcontrol_mai:autoreponsesubject_value')
  orof self.nocolon('mailboxesformcontrol_mai:autoresponsetext_value')
  orof self.nocolon('mailboxesformcontrol_mai:autoresponsetext_value')
    MailboxesFormControl(self,Net:Web:Div)
    self.Sendfooter(11)
    loc:Done = 1
  End ! Case


p_web._SetMobile PROCEDURE


  CODE
  PARENT._SetMobile
    p_web.Mobile = 0

