  MEMBER('Cart.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
Cart_BC0:DctInit    PROCEDURE
Cart_BC0:DctKill    PROCEDURE
Cart_BC0:FilesInit  PROCEDURE
  END

Hide:Access:Carts    CLASS(FileManager),TYPE               ! FileManager for Carts
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Carts    CLASS(RelationManager),TYPE           ! RelationManager for Carts
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:CartLines CLASS(FileManager),TYPE              ! FileManager for CartLines
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:CartLines CLASS(RelationManager),TYPE          ! RelationManager for CartLines
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


_Hide:Access:Carts   &Hide:Access:Carts,AUTO,THREAD
_Hide:Relate:Carts   &Hide:Relate:Carts,AUTO,THREAD
_Hide:Access:CartLines &Hide:Access:CartLines,AUTO,THREAD
_Hide:Relate:CartLines &Hide:Relate:CartLines,AUTO,THREAD


Cart_BC0:DctInit PROCEDURE
  CODE
  _Hide:Access:Carts &= NEW(Hide:Access:Carts)
  _Hide:Relate:Carts &= NEW(Hide:Relate:Carts)
  _Hide:Access:CartLines &= NEW(Hide:Access:CartLines)
  _Hide:Relate:CartLines &= NEW(Hide:Relate:CartLines)
  Relate:Carts &= _Hide:Relate:Carts
  Relate:CartLines &= _Hide:Relate:CartLines


Cart_BC0:FilesInit PROCEDURE
  CODE
  _Hide:Relate:Carts.Init
  _Hide:Relate:CartLines.Init


Cart_BC0:DctKill PROCEDURE
  CODE
  _Hide:Relate:Carts.Kill
  DISPOSE(_Hide:Relate:Carts)
  _Hide:Relate:CartLines.Kill
  DISPOSE(_Hide:Relate:CartLines)


Hide:Relate:Carts.Init PROCEDURE
  CODE
  _Hide:Access:Carts.Init
  SELF.Init(Access:Carts,1)


Hide:Access:Carts.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= Cart:Record
  SELF.FileNameValue = 'Carts'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Carts
  PARENT.Init
  Access:Carts &= SELF


Hide:Access:Carts.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Carts &= NULL                                     ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Carts.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Carts,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(Cart:KeyID,'Cart:KeyID',1)
    SELF.AddKey(Cart:KeyCustomer,'Cart:KeyCustomer',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Carts.Kill PROCEDURE

  CODE
  _Hide:Access:Carts.Kill                                  ! Kill the file manager
  PARENT.Kill
  Relate:Carts &= NULL                                     ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Carts)                              ! destroy the file manager


Hide:Relate:CartLines.Init PROCEDURE
  CODE
  _Hide:Access:CartLines.Init
  SELF.Init(Access:CartLines,1)


Hide:Access:CartLines.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= CartLine:Record
  SELF.FileNameValue = 'CartLines'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= CartLines
  PARENT.Init
  Access:CartLines &= SELF


Hide:Access:CartLines.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:CartLines &= NULL                                 ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:CartLines.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(CartLines,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(CartLine:KeyID,'CartLine:KeyID',1)
    SELF.AddKey(CartLine:KeyCart,'CartLine:KeyCart',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:CartLines.Kill PROCEDURE

  CODE
  _Hide:Access:CartLines.Kill                              ! Kill the file manager
  PARENT.Kill
  Relate:CartLines &= NULL                                 ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:CartLines)                          ! destroy the file manager

