  MEMBER('Taxi.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
Taxi_BC0:DctInit    PROCEDURE
Taxi_BC0:DctKill    PROCEDURE
Taxi_BC0:FilesInit  PROCEDURE
  END

Hide:Access:Taxis    CLASS(FileManager),TYPE               ! FileManager for Taxis
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
PrimeFields            PROCEDURE(),PROC,DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Taxis    CLASS(RelationManager),TYPE           ! RelationManager for Taxis
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


_Hide:Access:Taxis   &Hide:Access:Taxis,AUTO,THREAD
_Hide:Relate:Taxis   &Hide:Relate:Taxis,AUTO,THREAD


Taxi_BC0:DctInit PROCEDURE
  CODE
  _Hide:Access:Taxis &= NEW(Hide:Access:Taxis)
  _Hide:Relate:Taxis &= NEW(Hide:Relate:Taxis)
  Relate:Taxis &= _Hide:Relate:Taxis


Taxi_BC0:FilesInit PROCEDURE
  CODE
  _Hide:Relate:Taxis.Init


Taxi_BC0:DctKill PROCEDURE
  CODE
  _Hide:Relate:Taxis.Kill
  DISPOSE(_Hide:Relate:Taxis)


Hide:Relate:Taxis.Init PROCEDURE
  CODE
  _Hide:Access:Taxis.Init
  SELF.Init(Access:Taxis,1)


Hide:Access:Taxis.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= Taxi:Record
  SELF.FileNameValue = 'Taxis'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Taxis
  PARENT.Init
  Access:Taxis &= SELF


Hide:Access:Taxis.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Taxis &= NULL                                     ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Taxis.PrimeFields PROCEDURE

  CODE
  Taxi:DateCreated = today()                               ! Assign initial field value
  Taxi:TimeCreated = clock()                               ! Assign initial field value
  PARENT.PrimeFields


Hide:Access:Taxis.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Taxis,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(Taxi:KeyID,'Taxi:KeyID',1)
    SELF.AddKey(Taxi:KeyDriver,'Taxi:KeyDriver',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Taxis.Kill PROCEDURE

  CODE
  _Hide:Access:Taxis.Kill                                  ! Kill the file manager
  PARENT.Kill
  Relate:Taxis &= NULL                                     ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Taxis)                              ! destroy the file manager

