var DDSocketApp = DDSocketApp || {};

DDSocketApp.OpenEvent = "opened";
DDSocketApp.CloseEvent = "close";
DDSocketApp.MessageEvent = "message";
DDSocketApp.ErrorEvent = "error";

DDSocketApp.SocketBase = function (uri, callback) {
    var self = this;

    self.ws = null;
    self.uri = uri;
    self.callback = callback;

    //public methods
    self.supported = function () {
        return window.WebSocket != null;
    }    

    self.connect = function () {
        if (self.ws == null && self.supported()) {
            self.ws = new WebSocket(uri);
            self.ws.onopen = self.handleOpen;
            self.ws.onclose = self.handleClose;
            self.ws.onmessage = self.handleMessage;
            self.ws.onerror = self.handleError;
        }
    }

    self.send = function (txt) {
        if (self.ws != null)
            self.ws.send(txt);
    }

    self.close = function () {
        self.ws.close();
    }

    //events
    self.handleOpen = function (evt) {
        self.callback(DDSocketApp.OpenEvent, evt);
    }
    self.handleClose = function (evt) {
        self.callback(DDSocketApp.CloseEvent, evt);
        self.ws = null;
    }
    self.handleMessage = function (evt) {
        self.callback(DDSocketApp.MessageEvent, evt);
    }
    self.handleError = function (evt) {
        self.callback(DDSocketApp.ErrorEvent, evt);
        self.ws = null;
    }
    
}